/*
	Word Twiddle
	JavaScript game engine
	Version 0.9
	Copyright 2011 by Andrew Krywaniuk

	Includes code samples (getCheckedValue, setCheckedValue) from: http://www.somacon.com/p143.php
	
	License is hereby granted to freely distribute this game for personal and non-commercial use.
	For other uses, please contact the author.
*/



// return the value of the radio button that is checked
// return an empty string if none are checked, or
// there are no radio buttons
function getCheckedValue(radioObj)
{
	if(!radioObj)
		return "";
	var radioLength = radioObj.length;
	if(radioLength == undefined)
		if(radioObj.checked)
			return radioObj.value;
		else
			return "";
	for(var i = 0; i < radioLength; i++) {
		if(radioObj[i].checked) {
			return radioObj[i].value;
		}
	}
	return "";
}

// set the radio button with the given value as being checked
// do nothing if there are no radio buttons
// if the given value does not exist, all the radio buttons
// are reset to unchecked
function setCheckedValue(radioObj, newValue)
{
	if(!radioObj)
		return;
	var radioLength = radioObj.length;
	if(radioLength == undefined) {
		radioObj.checked = (radioObj.value == newValue.toString());
		return;
	}
	for(var i = 0; i < radioLength; i++) {
		radioObj[i].checked = false;
		if(radioObj[i].value == newValue.toString()) {
			radioObj[i].checked = true;
		}
	}
}

function save_config_data()
{
	var pw = window.parent;
	var o_form = document.forms[0];
	
	var wd_len = getCheckedValue(o_form.bingo_len);
	var rd_len = getCheckedValue(o_form.round_len);
	var dictionary = getCheckedValue(o_form.dictionary);
	var num_rounds = parseInt($("eb_num_rounds").value);
	
	dbg_msg("wd_len = " + wd_len);
	dbg_msg("rd_len = " + rd_len);

	if (dictionary != pw.g_dictionary_name)
	{
		pw.g_dictionary_name = dictionary;
		pw.load_dictionary(dictionary);
	}
	
	pw.g_bingo_length = wd_len;
	pw.g_round_time = rd_len;
	
	if (pw.g_num_rounds != num_rounds)
	{
		pw.set_num_rounds(num_rounds);
	}
	
	pw.update_game_desc();
}


function load_config_data()
{
	var pw = window.parent;
	var o_form = document.forms[0];

	var wd_len = pw.g_bingo_length;
	var rd_len = pw.g_round_time;
	var dictionary = pw.g_dictionary_name;
	var num_rounds = pw.g_num_rounds;

	dbg_msg("num_rounds = " + num_rounds);
	dbg_msg("rd_len = " + rd_len);
	
	setCheckedValue(o_form.bingo_len, wd_len);
	setCheckedValue(o_form.round_len, rd_len);
	setCheckedValue(o_form.dictionary, dictionary);
	$("eb_num_rounds").value = num_rounds;
}


function validate_config_data()
{
	var eb_nr = $("eb_num_rounds");
	var num_rounds = parseInt(eb_nr.value);
	if (!num_rounds || num_rounds > 100)
	{
		alert("Number of rounds should be between 1 and 100");
		eb_nr.focus();
		return false;
	}
	
	return true;
}


function dlg_okay()
{
	if (!validate_config_data()) return;
	
	save_config_data();
	window.parent.close_modal_dlg();
}


function dlg_cancel()
{
	window.parent.close_modal_dlg();
}


function init_config_dlg()
{
	load_config_data();
}

window.onload = init_config_dlg;

